/*

* EXP_GUIDIALOG.PRG

* // ( 26.05.2011 )

*  COBA Systems Software
* BAST Open Source Project
* Business Account Software Technology
* www.cobasystems.com

*/


/*

eXpress++ code

Jedan GUI dialog se moe startovati bezboroj puta u bezbroj instanci.
Ovde je dat primer pisanja GUI dialoga koji se ne moe startovati
dva puta jer se proverava preko njegovog windows hendlera da li je
ve startovan.

Koristi se kod aplikacija koje dozvoljavaju da se istovremeno
startuje vie GUI dialoga, odnosno daju mogunost starta jednog
istog GUI dialoga vie puta (u vie instanci)

*/

#include "common.ch"
#include "appevent.ch"
#include "xbp.ch"
#include "font.ch"
#include "gra.ch"
#include "xbtsys.ch"

#include "dctree.ch"
#include "dcdialog.ch"


// VANO
//
// Ako je GetList1 LOCAL tada se mora poslati ovoj
// funkciji kao parametar @GetList1 da ga aurira
// Funkcija mora da primi kao parametar GetList1
// iz glavnog programa - inae ne radi sve kako treba !
//
// Zbog toga je najbolje da je GetList1 PUBLIC varijabla
// pa se ne mora slati kao parametar @GetList
// a tada najmanje problema ima i sve najbolje radi
// kada se ova funkcija nalazi u istom PRG modulu
// u kome je i GetList1.
//
// Jo je vanije i treba znati da svaki od programa
// dcreadgui1(), dcreadgui2(), dcreadgui3(), ako bude
// poseban exe ili dll modul radie bez problema
//
// eXpress++ kod - istovremeni rad sa vie prozora // EXP_GUIDIALOG.PRG
// UPOTREBA iz dialoga menija:
//
//  dcreadgui1(prog,@getlist1)
//  dcreadgui2(prog,@getlist1)
//  dcreadgui3(prog,@getlist1)
//
// Glavni program iz koga se pozivaju ova tri prozora
// mora da ima komandu DCREAD GUI u svemu kako je ovde data:
// DCREAD GUI TITLE GlavniTitle  ;
//        OPTIONS GetOptions     ;
//        FIT ; // ZA RAD SA VIE POSEBNIH PROZORA KOJI SE FORMIRAJU ODAVDE:
//              PARENT @oDlgGlavni     ;     // MORA DA POSTOJI KOMANDA
//              APPWINDOW @oDlgGlavni  ;     // MORA DA POSTOJI KOMANDA
//              CLEAREVENTS            ;     // MORA DA POSTOJI KOMANDA
//              MULTILISTS             ;     // MORA DA POSTOJI KOMANDA
//              MODAL                  ;     // MORA DA POSTOJI KOMANDA
//              EVAL {|o| SetAppWindow(o) }  // MORA DA POSTOJI KOMANDA
**************************************************
FUNCTION dcreadgui1(prog,GetList1)
**************************************************
STATIC hw1 := 0
LOCAL GetList := {},  GetOptions
PUBLIC oDlg11

   IF hw1 > 0    // VANO ZA DRUGU INSTANCU PROZORA
       oDlg11:ToFront()
       SetAppFocus(oDlg11)
      RETURN NIL
   ENDIF

tone(1000)
set date german; set century on
datum := date(); naziv := PADR(prog,40)
@ 1,1 DCSAY prog SAYSIZE 0 FONT "14.Verdana Bold"
@ 5,1 DCSAY "Upis datuma dokumenta" GET datum
@ 6,1 DCSAY "Upis naziva dokumenta" GET naziv GETSIZE 20

@ 9,1 DCSTATIC TYPE XBPSTATIC_TYPE_TEXT SIZE 60, 10 ;
      OPTIONS XBPSTATIC_TEXT_WORDBREAK CAPTION { || TEKST() }

@ 19,1 DCPUSHBUTTON CAPTION "Kraj" SIZE 10,1.2 ;
       ACTION {|| implode(oDlg11), DC_ReadGuiEvent(DCGUI_EXIT_OK,GetList) }

DCGETOPTIONS COLOR {220,240,150} ;
WINDOWCOL 0 WINDOWROW 0 WINDOWHEIGHT 440 WINDOWWIDTH 434 ;
BORDER XBPDLG_NO_BORDER NOTITLEBAR  //NOMINBUTTON NOMAXBUTTON TABSTOP NOTASKLIST

DCREAD GUI TITLE prog OPTIONS GetOptions ;
              PARENT @oDlg11             ;        // POSTAVKA ZA PROZOR U PROZORU
              APPWINDOW @oPanel2         ;        // POSTAVKA ZA PROZOR U PROZORU
              CLEAREVENTS                ;
                        EVAL {|o| SetAppWindow(o) ,;
                        hw1 := o:getHWND(),;      // ZA DRUGU INSTANCU PROZORA
                        explode(oDlg11,hw1) }     // ZA EXPLODE EFEKAT

hw1 := 0       // ZBOG STATIC hw1 - OVO MORA DA BUDE OVDE
RELEASE oDlg11 // PUBLIC oDlg11 mora da se obrie !
Gkraj()        // REPAINT EKRANA - LOGO SLIKE EKRANA
RETURN NIL



**************************************************
FUNCTION dcreadgui2(prog,GetList1)
**************************************************
STATIC hw2 := 0
LOCAL GetList := {},  GetOptions
PUBLIC oDlg12

   IF hw2 > 0    // VANO ZA DRUGU INSTANCU PROZORA
       oDlg12:ToFront()
       SetAppFocus(oDlg12)
      RETURN NIL
   ENDIF
tone(1000)
set date german; set century on
datum := date(); naziv := PADR(prog,40)
@ 1,1 DCSAY prog SAYSIZE 0 FONT "14.Verdana Bold"
@ 5,1 DCSAY "Upis datuma dokumenta" GET datum
@ 6,1 DCSAY "Upis naziva dokumenta" GET naziv GETSIZE 20

@ 19,1 DCPUSHBUTTON CAPTION "Kraj" SIZE 10,1.2 ;
       ACTION {|| implode(oDlg12), DC_ReadGuiEvent(DCGUI_EXIT_OK,GetList) }

DCGETOPTIONS COLOR {220,240,200} ;
WINDOWCOL 0 WINDOWROW 0 WINDOWHEIGHT 440 WINDOWWIDTH 434 ;
BORDER XBPDLG_NO_BORDER NOTITLEBAR  // NOMINBUTTON NOMAXBUTTON TABSTOP NOTASKLIST

DCREAD GUI TITLE prog OPTIONS GetOptions ;
              PARENT @oDlg12             ;        // POSTAVKA ZA PROZOR U PROZORU
              APPWINDOW @oPanel2         ;        // POSTAVKA ZA PROZOR U PROZORU
              CLEAREVENTS                ;
                        EVAL {|o| SetAppWindow(o),;
                        hw2 := o:getHWND(),;      // ZA DRUGU INSTANCU PROZORA
                        explode(oDlg12,hw2) }     // ZA EXPLODE EFEKAT

hw2 := 0       // ZBOG STATIC hw1 - OVO MORA DA BUDE OVDE
RELEASE oDlg12 // PUBLIC oDlg11 mora da se obrie !
Gkraj()        // REPAINT EKRANA - LOGO SLIKE EKRANA
RETURN NIL



**************************************************
FUNCTION dcreadgui3(prog,GetList1)
**************************************************
STATIC hw3 := 0
LOCAL GetList := {},  GetOptions
PUBLIC oDlg13

   IF hw3 > 0    // VANO ZA DRUGU INSTANCU PROZORA
       oDlg13:ToFront()
       SetAppFocus(oDlg13)
      RETURN NIL
   ENDIF
tone(1000)
set date german; set century on
datum := date(); naziv := PADR(prog,40)
@ 1,1 DCSAY prog SAYSIZE 0 FONT "14.Verdana Bold"
@ 5,1 DCSAY "Upis datuma dokumenta" GET datum
@ 6,1 DCSAY "Upis naziva dokumenta" GET naziv GETSIZE 20

@ 19,1 DCPUSHBUTTON CAPTION "Kraj" SIZE 10,1.2 ;
       ACTION {|| implode(oDlg13), DC_ReadGuiEvent(DCGUI_EXIT_OK,GetList) }

DCGETOPTIONS COLOR {220,240,250} ;
WINDOWCOL 0 WINDOWROW 0 WINDOWHEIGHT 440 WINDOWWIDTH 434 ;
BORDER XBPDLG_NO_BORDER NOTITLEBAR // NOMINBUTTON NOMAXBUTTON TABSTOP NOTASKLIST

DCREAD GUI TITLE prog OPTIONS GetOptions ;
              PARENT @oDlg13             ;        // POSTAVKA ZA PROZOR U PROZORU
              APPWINDOW @oPanel2         ;        // POSTAVKA ZA PROZOR U PROZORU
              CLEAREVENTS                ;
                        EVAL {|o| SetAppWindow(o),;
                        hw3 := o:getHWND(),;      // ZA DRUGU INSTANCU PROZORA
                        explode(oDlg13,hw3) }     // ZA EXPLODE EFEKAT

hw3 := 0       // ZBOG STATIC hw1 - OVO MORA DA BUDE OVDE
implode(oDlg13)
RELEASE oDlg13 // PUBLIC oDlg11 mora da se obrie !
Gkraj()        // REPAINT EKRANA - LOGO SLIKE EKRANA
RETURN NIL





**************************************************
FUNCTION explode(oDlg,hw)
**************************************************
// Za explode efekat postavi se
// WINDOWHEIGHT 400-15-10
// pa se pozove:
 * oDlg:setframestate(XBPDLG_FRAMESTAT_MAXIMIZED)
// isto moe i preko Windows API DLL funkcija
// uz upotrebu hw
RETURN NIL

**************************************************
FUNCTION implode(oDlg,hw)
**************************************************
  oDlg:setframestate(XBPDLG_FRAMESTAT_MINIMIZED)
// isto moe i preko Windows API DLL funkcija
// uz upotrebu hw
RETURN NIL

**************************************************
FUNCTION Gkraj() // OSVEAVANJE SLIKE EKRANA
**************************************************
// PUBLIC oPanel2, oTree
oPanel2:hide()
oPanel2:show()
SetAppFocus(oTree)
RETURN NIL


FUNCTION TEKST()
LOCAL ch := chr(13)+chr(10)
ctxt := ;
"eXpress++ code"+ch+;
"MULTIPLI DIALOZI Kalkulacije, Nivelacije, Fakture"+ch+;
" "+ch+;
"Jedan GUI dialog se moe startovati bezboroj puta u bezbroj instanci. "+;
"Ovde je dat primer pisanja GUI dialoga koji se ne moe startovati "+;
"dva puta jer se proverava preko njegovog windows hendlera da li je "+;
"ve startovan. "+ch+;
" "+ch+;
"Koristi se kod aplikacija koje dozvoljavaju da se istovremeno "+;
"startuje vie GUI dialoga, odnosno daju mogunost starta jednog "+;
"istog GUI dialoga vie puta (u vie instanci) "+ch+;
" "+ch+;
"Ovde se mogu istovremeno startovati tri dialoga: dialog Kalkulacije, "+;
"dialog Nivelacije i dialog Fakture, i moe se naizmenino raditi sa "+;
"svakim od njih. Ali Jedan isti dialog se ne moe dva puta startovati."

RETURN cTxt


*/


FUNCTION prazno();RETURN NIL   // ne moe da postoji PRG bez funkcija
