


*###################################################################################################

#include "Common.ch"
#include "Dll.ch"

// DLLFUNCTION GetClassNameA( nHwnd, @cBuf, nBufLen ) USING STDCALL FROM USER32.DLL
//
// Thats how to use GetClassNameA (the return value is the lenght of the string
// returned in cClassName
//
// cClassName := SPACE(250)
// ? GetClassNameA( oWin:GetHWND(), @cClassName, 250 )
// ? cClassName // "XbpDialog"
//


/*
   ChkPrevApp, coded in Xbase++

   The first and only parameter you have to pass is the ClassName of the
   top level window of your app.

   For a XbpDialog() window this is "XbpDialog", for a XbpCrt() object,
   it is "XbpPmtClass".

   If your app has no window...well, then you have to look for a different way,
   or create an "invisible" main window.

      za CRT
      IF Chk_PrevApp("XbpPmtClass","TEST PROZOR")
       * Ovaj EXE program vec je startovan
       QUIT
      ENDIF

      za GUI
      IF Chk_PrevApp("XbpDialog","TEST PROZOR")
       * Ovaj EXE program vec je startovan
       QUIT
      ENDIF


*/




/*
 * ShowWindow() Commands, from WINUSER.H
 */
#define SW_HIDE             0
#define SW_SHOWNORMAL       1
#define SW_NORMAL           1
#define SW_SHOWMINIMIZED    2
#define SW_SHOWMAXIMIZED    3
#define SW_MAXIMIZE         3
#define SW_SHOWNOACTIVATE   4
#define SW_SHOW             5
#define SW_MINIMIZE         6
#define SW_SHOWMINNOACTIVE  7
#define SW_SHOWNA           8
#define SW_RESTORE          9
#define SW_SHOWDEFAULT      10
#define SW_MAX              10


DLLFUNCTION FindWindowA( @ClassName, WinName )  USING STDCALL FROM USER32.DLL
DLLFUNCTION GetForegroundWindow()               USING STDCALL FROM USER32.DLL
DLLFUNCTION IsIconic( nHwnd )                   USING STDCALL FROM USER32.DLL
DLLFUNCTION GetLastActivePopup( nHwnd )         USING STDCALL FROM USER32.DLL
DLLFUNCTION ShowWindow( nHwnd, nCmdShow )       USING STDCALL FROM USER32.DLL
DLLFUNCTION BringWindowToTop( nHwnd )           USING STDCALL FROM USER32.DLL
DLLFUNCTION SetForegroundWindow( nHwnd )        USING STDCALL FROM USER32.DLL
DLLFUNCTION GetWindowThreadProcessId( nForgroundHwnd, @nRetProcId ) USING STDCALL FROM USER32.DLL



***************************************************************
 FUNCTION WIN_START(cWinTitle)
***************************************************************
* na osnovu naziva prozora utvruje da li je prozor startovan
* PRIMENA: postavlja se na start programa za formiranje prozora
* cWinTitle := "TEST WINDOW | Windows Title"
* IF WIN_START(cWinTitle) == .F.  // __WIN_START.PRG
*   RETURN NIL
* ENDIF



 * SetAppWindow():SetTitle("Test")
 DEFAULT cWinTitle TO setappwindow():GetTitle()

 IF Chk_PrevApp("XbpDialog",cWinTitle)

        *msgbox( cWinTitle,"Ovaj prozor je startovan")
        Tone(4000)
        * cClass := "XbpDialog"; cWTitle := cWinTitle
        * nHwnd := FindWindowA( @cClass, @cWTitle ) // The window handle
        * BringWindowToTop( nHwnd ) // POSTAVI FOKUS NA OVAJ PROZOR...
        RETURN .F.                  // ... I NE STARTUJ PROZOR PONOVO


 ELSE
        *msgbox( cWinTitle,"Ovaj prozor nije startovan")
        RETURN .T. // STARTUJ PROZOR
 ENDIF

RETURN .F.


***********************************************
FUNCTION Chk_PrevApp( cClass , cWinTitle )
***********************************************

   LOCAL lRet := .F.
   LOCAL nHwndFind, nHwndForeground, nForegroundId
   LOCAL nFindId, nHwndLast

   // Until now I haven't figured out why the second Parameter of FindWindowA()
   // does not work as expected, maybe someone else can find it out...
   // (is this a known bug in the WIN32 API?)
   nHwndFind := FindWindowA( @cClass, @cWinTitle )

   *MsgBox( var2char(nHwndFind),"Hendler")


   If nHwndFind # 0  // ako je prozor startovan

      nHwndForeground := GetForegroundWindow()
      nForeGroundId   := GetWindowThreadProcessId( nHwndForeground, 0 )
      nFindId         := GetWindowThreadProcessId( nHwndFind, 0 )
      If nForeGroundId != nFindId .OR. IsIconic( nHwndFind ) # 0
         nHwndLast := GetLastActivePopup( nHwndFind )
         If IsIconic( nHwndLast ) # 0
            ShowWindow( nHwndLast, SW_RESTORE )
         EndIF
         BringWindowToTop( nHwndLast )
         SetForegroundWindow( nHwndLast )

      EndIF
      lRet := .T.

   Else  // ako prozor nije startovan

   EndIF

RETURN lRet


/*

 Actually I've only used it in one app that did use XbpDialog, so I can't say for
 sure. I would imagine that if you had an Class called "MyDialog" that was based
 on XbpDialog, and then called ChkPrevApp("MyDialog") that it would work for that
 as well. I would also imagine if you had two applications and both application
 A and application B were both based on XbpDialog and A was running, it would
 probably prevent B from running. But like I said I haven't tested any of that,
 so it's worth investigating.

*/
